package org.sonatype.nexus.maven.staging.workflow;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on nexus-staging-maven-plugin.<br/> Call <pre>  mvn nexus-staging:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Thu Nov 01 13:52:27 CDT 2012
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.sonatype.plugins:nexus-staging-maven-plugin:1.2", 0 );
        append( sb, "", 0 );

        append( sb, "Nexus Maven Plugins : Nexus Staging", 0 );
        append( sb, "Maven plugin side of Nexus Staging Suite.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 12 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "close".equals( goal ) )
        {
            append( sb, "nexus-staging:close", 0 );
            append( sb, "Closes a Nexus staging repository.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the staging repository ID on remote Nexus against which staging action should happen. If not given, mojo will fail. If not given, the properties file from local staging repository will be consulted.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deploy".equals( goal ) )
        {
            append( sb, "nexus-staging:deploy", 0 );
            append( sb, "Alternative deploy mojo, that will select proper DeployStrategy to perform deploys. Hence, this mojo might function in same was as maven-deploy-plugin\'s deploy mojo, but also might do deferred deploy or staging.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnFailure", 2 );
                append( sb, "Controls whether the plugin remove or keep the staging repository that performed an IO exception during upload, hence, it\'s contents are partial Defaults to {{false}}. If {{true}}, even in case of upload failure, the staging repository (with partial content) will be left as is, left to the user to do whatever he wants.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "skipLocalStaging", 2 );
                append( sb, "Set this to true to bypass staging features completely, and make this plugin behave in exact way as \'maven-deploy-plugin\' would, such as deploying at \'deploy\' phase in every module build to remote. In this case, the repository deployment goes against is taken in from Dependency Management section, again, same as in case of \'maven-deploy-plugin\'.", 3 );
                append( sb, "Expression: ${skipLocalStaging}", 3 );
                append( sb, "", 0 );

                append( sb, "skipNexusStagingDeployMojo", 2 );
                append( sb, "Set this to true to bypass this mojo altogether (skip complete Mojo execution).", 3 );
                append( sb, "Expression: ${skipNexusStagingDeployMojo}", 3 );
                append( sb, "", 0 );

                append( sb, "skipRemoteStaging", 2 );
                append( sb, "Set this to true to bypass remote staging (upload of locally staged artifacts) that would happen once last project is being locally staged.", 3 );
                append( sb, "Expression: ${skipRemoteStaging}", 3 );
                append( sb, "", 0 );

                append( sb, "skipStaging", 2 );
                append( sb, "Set this to true to bypass staging features, and use deferred deploy features only.", 3 );
                append( sb, "Expression: ${skipStaging}", 3 );
                append( sb, "", 0 );

                append( sb, "skipStagingRepositoryClose", 2 );
                append( sb, "Set this to true to bypass staging repository closing at the workflow end.", 3 );
                append( sb, "Expression: ${skipStagingRepositoryClose}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingProfileId", 2 );
                append( sb, "Specifies the profile ID on remote Nexus against which staging should happen. If not given, Nexus will be asked to perform a \'match\' and that profile will be used.", 3 );
                append( sb, "Expression: ${stagingProfileId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the (opened) staging repository ID on remote Nexus against which staging should happen. If not given, Nexus will be asked to create one for us and that will be used.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "tags", 2 );
                append( sb, "The key-value pairs to \'tag\' the staging repository.", 3 );
                append( sb, "", 0 );

                append( sb, "updateReleaseInfo (Default: false)", 2 );
                append( sb, "Parameter used to update the metadata to make the artifact as release.", 3 );
                append( sb, "Expression: ${updateReleaseInfo}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deploy-staged".equals( goal ) )
        {
            append( sb, "nexus-staging:deploy-staged", 0 );
            append( sb, "Deploys the (previously) locally staged artifacts from nexus-staging repository, that were staged using DeployMojo and having the skipRemoteStaging flag set to true.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnFailure", 2 );
                append( sb, "Controls whether the plugin remove or keep the staging repository that performed an IO exception during upload, hence, it\'s contents are partial Defaults to {{false}}. If {{true}}, even in case of upload failure, the staging repository (with partial content) will be left as is, left to the user to do whatever he wants.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "skipStaging", 2 );
                append( sb, "Set this to true to bypass staging features, and use deferred deploy features only.", 3 );
                append( sb, "Expression: ${skipStaging}", 3 );
                append( sb, "", 0 );

                append( sb, "skipStagingRepositoryClose", 2 );
                append( sb, "Set this to true to bypass staging repository closing at the workflow end.", 3 );
                append( sb, "Expression: ${skipStagingRepositoryClose}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingProfileId", 2 );
                append( sb, "Specifies the profile ID on remote Nexus against which staging should happen. If not given, Nexus will be asked to perform a \'match\' and that profile will be used.", 3 );
                append( sb, "Expression: ${stagingProfileId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the (opened) staging repository ID on remote Nexus against which staging should happen. If not given, Nexus will be asked to create one for us and that will be used.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "tags", 2 );
                append( sb, "The key-value pairs to \'tag\' the staging repository.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "deploy-staged-repository".equals( goal ) )
        {
            append( sb, "nexus-staging:deploy-staged-repository", 0 );
            append( sb, "Deploys the (previously) staged artifacts from some local repository, that were staged using maven-deploy-plugin together with switch altDeploymentRepository for cases when POM modifications are not possible for some reason. In contrast to DeployMojo and DeployStagedMojo mojos, this mojo takes an \'image\' of the previously deployed (to local FS) in some previous build, and uploads the whole directory (with all files and subdirectories) \'as-is\' to a staging repository on Nexus. Naturally, this will would work only for a build of a released project (like a tag checkout). Since POM is not editable -- otherwise you would not be using this but the DeployMojo --, the intent with this Mojo is to be called directly, fully parameterized. At least, you have to set nexusUrl, serverId, stagingProfileId (also stagingRepositoryId if needed) and repositoryDirectory parameters on CLI.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnFailure", 2 );
                append( sb, "Controls whether the plugin remove or keep the staging repository that performed an IO exception during upload, hence, it\'s contents are partial Defaults to {{false}}. If {{true}}, even in case of upload failure, the staging repository (with partial content) will be left as is, left to the user to do whatever he wants.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "repositoryDirectory", 2 );
                append( sb, "Specifies an the location of staging directory to which the project artifacts was staged using maven-deploy-plugin together with switch altDeploymentRepository. Note: this parameters if of type File, it has to point to an existend FS directory!", 3 );
                append( sb, "Expression: ${repositoryDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "skipStaging", 2 );
                append( sb, "Set this to true to bypass staging features, and use deferred deploy features only.", 3 );
                append( sb, "Expression: ${skipStaging}", 3 );
                append( sb, "", 0 );

                append( sb, "skipStagingRepositoryClose", 2 );
                append( sb, "Set this to true to bypass staging repository closing at the workflow end.", 3 );
                append( sb, "Expression: ${skipStagingRepositoryClose}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingProfileId", 2 );
                append( sb, "Specifies the profile ID on remote Nexus against which staging should happen. If not given, Nexus will be asked to perform a \'match\' and that profile will be used.", 3 );
                append( sb, "Expression: ${stagingProfileId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the (opened) staging repository ID on remote Nexus against which staging should happen. If not given, Nexus will be asked to create one for us and that will be used.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );

                append( sb, "tags", 2 );
                append( sb, "The key-value pairs to \'tag\' the staging repository.", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "drop".equals( goal ) )
        {
            append( sb, "nexus-staging:drop", 0 );
            append( sb, "Drops a Nexus staging repository that is either open or closed.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the staging repository ID on remote Nexus against which staging action should happen. If not given, mojo will fail. If not given, the properties file from local staging repository will be consulted.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "nexus-staging:help", 0 );
            append( sb, "Display help information on nexus-staging-maven-plugin.\nCall\n\u00a0\u00a0mvn\u00a0nexus-staging:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "promote".equals( goal ) )
        {
            append( sb, "nexus-staging:promote", 0 );
            append( sb, "Promotes a closed Nexus staging repository into a Nexus Build Promotion Profile.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "buildPromotionProfileId", 2 );
                append( sb, "Specifies the staging build promotion profile ID on remote Nexus where to promotion happens. If not specified, goal will fail.", 3 );
                append( sb, "Expression: ${buildPromotionProfileId}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the staging repository ID on remote Nexus against which staging action should happen. If not given, mojo will fail. If not given, the properties file from local staging repository will be consulted.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "rc-close".equals( goal ) )
        {
            append( sb, "nexus-staging:rc-close", 0 );
            append( sb, "Closes a Nexus staging repository.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the (opened) staging repository ID (or multiple ones comma separated) on remote Nexus against which RC staging action should happen. If not given, mojo will fail.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "rc-drop".equals( goal ) )
        {
            append( sb, "nexus-staging:rc-drop", 0 );
            append( sb, "Drops a Nexus staging repository that is either open or closed.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the (opened) staging repository ID (or multiple ones comma separated) on remote Nexus against which RC staging action should happen. If not given, mojo will fail.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "rc-promote".equals( goal ) )
        {
            append( sb, "nexus-staging:rc-promote", 0 );
            append( sb, "Promotes a closed Nexus staging repository into a Nexus Build Promotion Profile.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "buildPromotionProfileId", 2 );
                append( sb, "Specifies the staging build promotion profile ID on remote Nexus where to promotion happens. If not specified, goal will fail.", 3 );
                append( sb, "Expression: ${buildPromotionProfileId}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the (opened) staging repository ID (or multiple ones comma separated) on remote Nexus against which RC staging action should happen. If not given, mojo will fail.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "rc-release".equals( goal ) )
        {
            append( sb, "nexus-staging:rc-release", 0 );
            append( sb, "Releases a single closed Nexus staging repository into a permanent Nexus repository for general consumption.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the (opened) staging repository ID (or multiple ones comma separated) on remote Nexus against which RC staging action should happen. If not given, mojo will fail.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "release".equals( goal ) )
        {
            append( sb, "nexus-staging:release", 0 );
            append( sb, "Releases a single closed Nexus staging repository into a permanent Nexus repository for general consumption.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "altStagingDirectory", 2 );
                append( sb, "Specifies an alternative staging directory to which the project artifacts should be \'locally staged\'. By default, staging directory will be looked for under ${project.build.directory /nexus-staging folder of the first encountered module that has this Mojo defined for execution (Warning: this means, if top level POM is an aggregator, it will be NOT in top level!).", 3 );
                append( sb, "Expression: ${altStagingDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "description", 2 );
                append( sb, "The repository \'description\' to pass to Nexus when repository staging workflow step is made. If none passed in, plugin defaults are applied.", 3 );
                append( sb, "Expression: ${description}", 3 );
                append( sb, "", 0 );

                append( sb, "keepStagingRepositoryOnCloseRuleFailure", 2 );
                append( sb, "Controls whether the staging repository is kept or not (it will be dropped) in case of staging rule failure when \'close\' action is performed against it. This is applied in both cases, DeployMojo and CloseStageRepositoryMojo invocations.", 3 );
                append( sb, "Expression: ${keepStagingRepositoryOnCloseRuleFailure}", 3 );
                append( sb, "", 0 );

                append( sb, "nexusUrl", 2 );
                append( sb, "The base URL for a Nexus Professional instance that includes the nexus-staging-plugin.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${nexusUrl}", 3 );
                append( sb, "", 0 );

                append( sb, "serverId", 2 );
                append( sb, "The ID of the server entry in the Maven settings.xml from which to pick credentials to contact remote Nexus.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${serverId}", 3 );
                append( sb, "", 0 );

                append( sb, "stagingRepositoryId", 2 );
                append( sb, "Specifies the staging repository ID on remote Nexus against which staging action should happen. If not given, mojo will fail. If not given, the properties file from local staging repository will be consulted.", 3 );
                append( sb, "Expression: ${stagingRepositoryId}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List lines = new ArrayList();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
